_ServantLocatorStub (Java Platform SE 8 )
Keywords: org.omg.PortableServer._ServantLocatorStub class
Date: 2020-03-26

org.omg.PortableServer

## Class _ServantLocatorStub

- java.lang.Object
- - org.omg.CORBA.portable.ObjectImpl
  - - org.omg.PortableServer._ServantLocatorStub

- All Implemented Interfaces:
    Serializable, Object, IDLEntity, ServantLocator, ServantLocatorOperations, ServantManager, ServantManagerOperations

      public class _ServantLocatorStub
      extends ObjectImpl
      implements ServantLocator

  When the POA has the NON_RETAIN policy it uses servant managers that are ServantLocators. Because the POA knows that the servant returned by this servant manager will be used only for a single request, it can supply extra information to the servant manager's operations and the servant manager's pair of operations may be able to cooperate to do something different than a ServantActivator. When the POA uses the ServantLocator interface, immediately after performing the operation invocation on the servant returned by preinvoke, the POA will invoke postinvoke on the servant manager, passing the ObjectId value and the Servant value as parameters (among others). This feature may be used to force every request for objects associated with a POA to be mediated by the servant manager.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Class` | `_opsClass`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `_ServantLocatorStub()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String[]` | `_ids()` Retrieves a string array containing the repository identifiers supported by this `ObjectImpl` object.
    `void` | `postinvoke(byte[] oid, POA adapter, String operation, Object the_cookie, Servant the_servant)` This operation is invoked whenener a servant completes a request.
    `Servant` | `preinvoke(byte[] oid, POA adapter, String operation, CookieHolder the_cookie)` This operations is used to get a servant that will be used to process the request that caused preinvoke to be called.

    - ### Methods inherited from class org.omg.CORBA.portable.ObjectImpl

      `_create_request, _create_request, _duplicate, _get_delegate, _get_domain_managers, _get_interface_def, _get_policy, _hash, _invoke, _is_a, _is_equivalent, _is_local, _non_existent, _orb, _release, _releaseReply, _request, _request, _servant_postinvoke, _servant_preinvoke, _set_delegate, _set_policy_override, equals, hashCode, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.omg.CORBA.Object

      `_create_request, _create_request, _duplicate, _get_domain_managers, _get_interface_def, _get_policy, _hash, _is_a, _is_equivalent, _non_existent, _release, _request, _set_policy_override`

- - ### Field Detail

    - #### _opsClass

          public static final Class _opsClass

  - ### Constructor Detail

    - #### _ServantLocatorStub

          public _ServantLocatorStub()

  - ### Method Detail

    - #### preinvoke

          public Servant preinvoke(byte[] oid,
                                   POA adapter,
                                   String operation,
                                   CookieHolder the_cookie)
                            throws ForwardRequest

      This operations is used to get a servant that will be used to process the request that caused preinvoke to be called.
      Specified by:
        `preinvoke` in interface `ServantLocatorOperations`
      Parameters:
        `oid` - the object id associated with object on which the request was made.
        `adapter` - the reference for POA in which the object is being activated.
        `operation` - the operation name.
        `the_cookie` - an opaque value that can be set by the servant manager to be used during postinvoke.
      Returns:
        Servant used to process incoming request.
      Throws:
        `ForwardRequest` - to indicate to the ORB that it is responsible for delivering the current request and subsequent requests to the object denoted in the forward_reference member of the exception.

    - #### postinvoke

          public void postinvoke(byte[] oid,
                                 POA adapter,
                                 String operation,
                                 Object the_cookie,
                                 Servant the_servant)

      This operation is invoked whenener a servant completes a request.
      Specified by:
        `postinvoke` in interface `ServantLocatorOperations`
      Parameters:
        `oid` - the object id ssociated with object on which the request was made.
        `adapter` - the reference for POA in which the object was active.
        `the_cookie` - an opaque value that contains the data set by preinvoke.
        `the_servant` - reference to the servant that is associated with the object.

    - #### _ids

          public String[] _ids()

      Description copied from class: `ObjectImpl`
      Retrieves a string array containing the repository identifiers supported by this `ObjectImpl` object. For example, for a stub, this method returns information about all the interfaces supported by the stub.
      Specified by:
        `_ids` in class `ObjectImpl`
      Returns:
        the array of all repository identifiers supported by this `ObjectImpl` instance

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2020, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.